Test2 = Core.class(Sprite)

function Test2:init()
    self:add_square({
        height = 100,
        width = 100,
        color = 0x000000
    })

    self:add_emitter()
end

function Test2:add_square(settings)
    local height = settings.height
    local width = settings.width
    local fill_style = Shape.SOLID
    local fill_color = settings.color
    local fill_alpha = 1
    local line_style = 0
    local line_color = settings.color
    local line_alpha = 1

    local square = Shape.new()
    square:setFillStyle(fill_style, fill_color, fill_alpha)
    square:setLineStyle(line_style, line_color, line_alpha)
    square:beginPath()
    square:moveTo(0,0)
    square:lineTo(width, 0)
    square:lineTo(width, height)
    square:lineTo(0, height)
    square:lineTo(0, 0)
    square:endPath()

    self:addChild(square)
end

function Test2:add_emitter()
    local particle = Texture.new('ember.png')

    -- create new emitter
    self.emitter = CEmitter.new(0, 0, 90, self)

    -- using this line instead moves the emission point, but doesn't fix the dimension problem
    -- self.emitter = CEmitter.new(self:getWidth() * 0.5, self:getHeight() * 0.5, 90, self)

    -- create particles
    local particleSprite = CParticles.new(particle, 10, 1, .7, 'add')
    particleSprite:setSpeed(150, 20)
    particleSprite:setDirection(0, 360)
    particleSprite:setColor(0, 0, 0, 255, 255, 255)
    particleSprite:setAlpha(0)
    particleSprite:setSizeMorphIn(5, 1.5, 0)
    particleSprite:setGravityForce(50, 250)
    particleSprite:setGravity(-50, 0)
    particleSprite:setAlphaMorphIn(255, .5)
    particleSprite:setAlphaMorphOut(0, .3)
    self.emitter:assignParticles(particleSprite)

    -- start the particle effect
    self.emitter:start()
end
